package com.castrianni.cvs;

import java.awt.BorderLayout;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.JLabel;

import org.jetbrains.annotations.Nullable;
import com.intellij.openapi.project.Project;
import com.intellij.openapi.ui.DialogWrapper;
import info.clearthought.layout.TableLayout;

public class TagFilterOptions extends DialogWrapper {
  protected JRadioButton _showTagR = null;
  protected JRadioButton _hideTagR = null;
  protected JTextField _tagFilterTF = null;
  protected TagFilterOptions.TagFilteringOptions _retVal = null;
  protected Project _project = null;

  public TagFilterOptions(Project project)
  {
    super(project,false);
    setTitle("Tag Filter Options");
    setModal(true);
    _project = project;
    init();
  }

  @Nullable
  protected JComponent createCenterPanel()
  {
    double tableSizes2[][] = {{TableLayout.PREFERRED,TableLayout.PREFERRED},{TableLayout.PREFERRED,TableLayout.PREFERRED}};
    TableLayout tl2 = new TableLayout(tableSizes2);
    tl2.setHGap(5);
    tl2.setVGap(5);
    JPanel radioP = new JPanel(tl2);
    radioP.setBorder(BorderFactory.createEtchedBorder());
    _showTagR = new JRadioButton("Show");
    radioP.add(_showTagR,"0,0,l,b");
    _hideTagR = new JRadioButton("Hide");
    radioP.add(_hideTagR,"0,1,l,t");
    radioP.add(new JLabel("tags of the form:"),"1,0,1,1,c,c");
    ButtonGroup bg = new ButtonGroup();
    bg.add(_showTagR);
    bg.add(_hideTagR);
    double tableSizes[][] = {{TableLayout.PREFERRED,TableLayout.FILL},{TableLayout.PREFERRED}};
    TableLayout tl = new TableLayout(tableSizes);
    tl.setHGap(5);
    tl.setVGap(5);
    JPanel retVal = new JPanel(tl);
    retVal.add(radioP,"0,0");
    _tagFilterTF = new JTextField(25);
    _tagFilterTF.setToolTipText("Use regular expression syntax");
    retVal.add(_tagFilterTF,"1,0,f,c");
    return(retVal);
  }

  protected void dispose()
  {
    _project = null;
    super.dispose();
  }

  protected void doOKAction()
  {
    _retVal = new TagFilterOptions.TagFilteringOptions();
    _retVal._showTagFilter = _showTagR.isSelected();
    _retVal._tagFilter = _tagFilterTF.getText();
    super.doOKAction();
  }

  public void show(boolean showTagFilter,String tagFilter)
  {
    if(showTagFilter)
      _showTagR.setSelected(true);
    else
      _hideTagR.setSelected(true);
    _tagFilterTF.setText(tagFilter);
    show();
  }

  public TagFilterOptions.TagFilteringOptions getReturnValue()
  {
    return(_retVal);
  }

  public void doCancelAction()
  {
    _retVal = null;
    super.doCancelAction();
  }

  public class TagFilteringOptions {
    public String _tagFilter = null;
    public boolean _showTagFilter;
  }
}
